//PIC24FJ64GA002 8MHz external clock (PLL=32MHz)
//
//HtSC1602ɂInput Capture eXgvO (gA\)
//2007.10.12  
//
//FMPLAB IDE v7.62
//RpCFC30 v3.01 (19 June 2007)
//C^[FPICkit2 v2.40
//
//RpCœK:R
//MPLAB C30t PIC24FCugp:libpPIC24Fxxx-coff.a
//
//@\ InputCapture1, InputCapture2, Timer2, Timer3
// Timer2+Timer3=32bit , 16MHz, ^C}[ςɂȂ܂270sec, 0.0037Hz
//
//Fjo[T
//            HtSC1602
//PORTB 15 -  DB7
//PORTB 14 -  DB6
//PORTB 13 -  DB5
//PORTB 12 -  DB4
//PORTB 11 -  E
//PORTB 10 -  RS
//            R/WGND
//
//PORTB 6  - LED
//
//OSCI - 8MHzO 22pFRfT
//OSCO - 8MHzO 22pFRfT
//
//RP7(16pin) - Input Capture1,2 M
//

#define USE_AND_OR     //CuORgp(CũCN[ht@COɒu)

#include <p24FJ64GA002.h>
#include <inCap.h>
#include <stdio.h>
#include "pinsel.h"  //for PinSel (p24FJ64GAincludeɒuĂ)
#include "lcd.h"

#define F_CPU           32000000UL  //CNbNg 32MHz

//#define INTERRUPT_ON  //荞݂gpȂƂ̓RgɂĂ

extern int delay_cycle(unsigned int n);
extern int delay_msec(unsigned int n, unsigned int m);

typedef struct tagUL32 {
 union {
    struct {
        unsigned int low16;
        unsigned int hi16;
    };
    unsigned long hilow32;
    };
} UL32;
volatile UL32 ic_timer[2];
volatile int Interrupt_Count1 , Interrupt_Count2, Int_flag1, Int_flag2;

//CONFIG͂ohbetm̂̂Qlɂ܂(FNOSC_PRIPLL, POSCMOD_HSLɂĂ܂)
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & ICS_PGx1 & FWDTEN_OFF )
_CONFIG2(IESO_OFF & FNOSC_PRIPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C1SEL_PRI & POSCMOD_HS)

void delay_ms(unsigned int ms)
{
    #define one_loop_cycle 1UL //one loop = 1 cycle
    #define clock_per_cycle 2UL // clock / cycle  (PTCNQNbNĂHH)
    #define delay_1msec_wk ((F_CPU/1000UL) / (one_loop_cycle*clock_per_cycle))
    #define delay_1msec_val (delay_1msec_wk-5UL) //-5UL͎ԕ␳l

    delay_msec(delay_1msec_val, ms);
}

#ifdef INTERRUPT_ON

//Input Capture1 Interrupt i16bitj
void __attribute__((__interrupt__)) _IC1Interrupt(void)
{
    IFS0bits.IC1IF = 0;

    Interrupt_Count1++;

    if(Interrupt_Count1 == 1){
        ic_timer[0].hi16 = IC1BUF;//16bit 1
    }
    else if(Interrupt_Count1 == 2){
        ic_timer[1].hi16 = IC1BUF;//16bit 2
        Int_flag1 = 1;
    }
}

//Input Capture2 Interrupt@i16bitj
void __attribute__((__interrupt__)) _IC2Interrupt(void)
{
    IFS0bits.IC2IF = 0;

    Interrupt_Count2++;

    if(Interrupt_Count2 == 1){
        ic_timer[0].low16 = IC2BUF;//16bit 1
    }
    else if(Interrupt_Count2 == 2){
        ic_timer[1].low16 = IC2BUF;//16bit 2
        Int_flag2 = 1;
    }
}
#endif

/*
void sort(unsigned long *buf, int cn)
{
    int i,j;
    unsigned long wk;
    
    for (i=0; i<cn-1; i++)
    {
        for (j=0; j<cn-1; j++)
        {
            if (buf[j+1] < buf[j])
            {
                wk = buf[j];
                buf[j] = buf[j+1];
                buf[j+1] = wk;
            }
        }
    }
}
*/

int main()
{
    char str[20];

    #define LED_BIT PORTBbits.RB6    //LED PORT BIT = RB6
    #define LED_DIR TRISBbits.TRISB6 //LED PORT DIR = output
    #define AVE_MAX 10 //ω

    int iave_max;
    float ave_f;
    float ave_period;
    unsigned long period[AVE_MAX], wku32;//32bit
    int i,ia;
    BOOL bFULL;

    iave_max = AVE_MAX;

    _RCDIV = 0;//PostScaler   ( 0 : 32MHz   1 : 16MHz )

    InPinSel(IFNC_IC1, PIN_RP7);//RP7(pin16)Input Capture1t܂
    InPinSel(IFNC_IC2, PIN_RP7);//RP7(pin16)Input Capture2t܂

    lcd_init();//|[g̏̒łȂĂ܂
    lcd_putstr("Input Capture    wait...");
    delay_ms(800);

    LED_DIR = 0;//LED PORT DIR output
    LED_BIT = 1;//LED OFF

    T3CON=0;// timer3 stop
    T2CON=0;// timer2 stop
    TMR3=0;// timer3 count clear
    TMR2=0;// timer2 count clear

    for(i=0;i<AVE_MAX;i++){
        period[i] = 0;
    }

    T2CON = 0x8008;//timer 2,3 A start

    ConfigIntCapture1(IC_INT_PRIOR_1);//16bit 荞݃vCIeB[, IC_INT_ONȂ
    ConfigIntCapture2(IC_INT_PRIOR_1);//16bit 荞݃vCIeB[, IC_INT_ONȂ

    while(1)
    {
        LED_BIT = 1;//LED OFF
        bFULL = FALSE;

        for(ia=0;ia<iave_max;ia++) //σ[v
        {
            ic_timer[0].hilow32 = 0;
            ic_timer[1].hilow32 = 0;
            Interrupt_Count1 = 0;
            Interrupt_Count2 = 0;
            Int_flag1 = 0;
            Int_flag2 = 0;

#ifdef INTERRUPT_ON
            IFS0 &= ~0b0000000000100010;//IC1IF , IC2IF 荞݃tOclear
            IEC0 |= 0b0000000000100010;//IC1IE , IC2IE 荞enable
#endif
            //OpenCapture1(IC_IDLE_STOP | IC_TIMER3_SRC | IC_INT_1CAPTURE | IC_EVERY_FALL_EDGE);// IC1 start
            //OpenCapture2(IC_IDLE_STOP | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_EVERY_FALL_EDGE);// IC2 start
            asm("mov.w #2,w0");
            asm("mov.w #0x82,w1");
            asm("mov.w w0, IC1CON");//IC1CON (OpenCapture1()Ɠ)
            asm("mov.w w1, IC2CON");//IC2CON (OpenCapture2()Ɠ)

            while(1)
            {//Lv`[li[̂҂[v
#ifdef INTERRUPT_ON
#else
                if(IC1CONbits.ICBNE) 
                {
                    Interrupt_Count1++;
                    if(1<=Interrupt_Count1 && Interrupt_Count1<=2)
                    {
                        ic_timer[Interrupt_Count1-1].hi16 = IC1BUF;
                    }  
                }
                if(IC2CONbits.ICBNE) 
                {
                    Interrupt_Count2++;
                    if(1<=Interrupt_Count2 && Interrupt_Count2<=2)
                    {
                        ic_timer[Interrupt_Count2-1].low16 = IC2BUF;
                    }  
                }
#endif
                //if(Int_flag1 && Int_flag2) break; // li[ꂽƂbreak
                if(Interrupt_Count1>=2 && Interrupt_Count2>=2) break; // li[ꂽƂbreak
                
                if(IC1CONbits.ICOV==1 || IC2CONbits.ICOV==1)
                {//FIFO FULL̂Ƃbreak (FIFO FULLɂȂƃLv`[~̂ŁAIwhile𔲂.ً}u)
                    bFULL = TRUE;
                    break;
                }
            }

            OpenCapture1(0);// IC1 stop, 0ł͎IFIFONA
            OpenCapture2(0);// IC2 stop, 0ł͎IFIFONA

#ifdef INTERRUPT_ON
            IEC0 &= ~0b0000000000100010;//IC1IE , IC2IE 荞disable
            IFS0 &= ~0b0000000000100010;//IC1IF , IC2IF 荞݃tOclear
#endif

            //vZ
            if(ic_timer[1].hilow32 >= ic_timer[0].hilow32)
            {
                period[ia] = ic_timer[1].hilow32 - ic_timer[0].hilow32;
            }
            else
            {
                wku32 = ic_timer[0].hilow32 - ic_timer[1].hilow32;
                period[ia] = (0xffffffffUL - wku32) + 1UL;
            }

            //ω񐔒@10Hzȉ1̂,ȏAVE_MAX
            if(period[0] >= ((F_CPU>>1)/10))
            {
                iave_max = 1;
                break;
            }
            else iave_max = AVE_MAX;

            if(bFULL==TRUE) break;//FIFIOFULLƂfor
        }

        if(bFULL==TRUE) continue;//FIFIOFULLƂŏwhileɖ߂

        LED_BIT = 0;//LED ON

        //όvZ
        ave_period=0;
        for(i=0;i<iave_max;i++)
        {
            ave_period += period[i];
        }
        ave_period /= (float)iave_max;
        if(ave_period!=0.0) ave_f = (float)(F_CPU>>1)/ave_period;//g傫Ȃƌ덷傫Ȃ܂
        else ave_f = 0.0;

        //t\
        sprintf(str,"Frq%11.3fHz",(double)ave_f);//g
        lcd_gotopos(0,0);//x=0, line=0
        lcd_putstr(str);
        sprintf(str,"T%13.6fms",(double)(ave_period*1000.0/(float)(F_CPU>>1)));//
        lcd_gotopos(0,1);//x=0, line=1
        lcd_putstr(str);
/*
       sprintf(str,"1 %08lx,%05lx", ic_timer[0], period[0]); //^C}[lifobOpj
       lcd_gotopos(0,0);//x=0, line=0
       lcd_putstr(str);
       sprintf(str,"2 %08lx,%05lx", ic_timer[1], period[1]);//^C}[lifobOpj
        lcd_gotopos(0,1);//x=0, line=0
        lcd_putstr(str);
*/
        delay_ms(100);
    }

    CloseCapture1();
    CloseCapture2();
    return 1;
}




